<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb6038ea32798897_77942078/OperatorStack_lb6038ea32798897_77942078.php';

class ControlFlow_lb6038ea32798897_77942078{

    protected $flowId;

    protected $flowName = 'Opportunities Set Currency Symbol';
    public static $operators;
    public static $links;

    public function __construct($flowId){
        $this->flowId = $flowId;
        $this->setData();
    }

    public function setData(){
        $data = $this->formatData();

        $this->setOperatorsMeta($data);
        $this->setLinksMeta($data);
    }

    public function clearStack(){
        self::getOperatorStack()->operators[$this->flowId] = array();
    }

    protected function formatData(){
        $operatorMeta = array();
        include 'custom/PxRoutines/LogicBuilderPackages/lb6038ea32798897_77942078/meta_lb6038ea32798897_77942078.php';
        return $operatorMeta;
    }

    protected function setOperatorsMeta($data){
        self::$operators[$this->flowId] = $data['operators']; //DataMapper::getOperators($data);
    }

    protected function setLinksMeta($data){
        self::$links[$this->flowId] = $data['links']; //DataMapper::getLinks($data);
    }

    public function process($params){
        if(!$this->isPackageActiveForExecution()){
            return;
        }

        $firstElem = $this->getFirstElement($params);

        $nextLinkParam = self::getNextLink($this->flowId, $firstElem->getElementId(), $firstElem->getOutControlPort());

        while(($nextLinkParam = self::getNextElement($this->flowId, $this->flowName, $nextLinkParam)) != false){}

//        $GLOBALS['log']->fatal('OPERATOR op-33: '.print_r(self::getOperatorStack()->operators[$this->flowId]['op-24'], true));
    }

    protected function isPackageActiveForExecution(){
        static $status;

        if(!isset($status)) {
            $db = DBManagerFactory::getInstance();
            if (!$db->tableExists('px_lb_package_info')){
                $status = true;
            }else{
                $packageId = 'lb6038ea32798897_77942078';
                $sql = "SELECT status from px_lb_package_info where package_id='$packageId'";
                $rs = $db->query($sql);
                $row = $db->fetchRow($rs);

                if ($row['status'] == 'disabled') {
                    $status = false;
                }else {
                    $status = true;
                }
            }
        }

        return $status;
    }

    /**
     * @param $params
     * @return FlowchartOperator_lb6038ea32798897_77942078
     */
    public function getFirstElement($params){
        foreach(self::$operators[$this->flowId] as $operator){
            if( //$operator['type'] == 'OnDataChangeOperator' || $operator['type'] == 'OnLinkChangeOperator' || $operator['type'] == 'ProcessEventOperator' ||
                in_array(
                    $operator['type'],
                    array(
                        'OnDataChangeOperator',
                        'OnLinkChangeOperator',
                        'ProcessEventOperator',
                        'OnServiceCallOperator',
                        'OnUserActionOperator',
                        'OnValidationOperator'
                    )
                )
            ){
                $params = array_merge($params, array('flowName' => $this->flowName));
                self::getOperatorStack()->getOperator($this->flowId, $operator)->process($params);
                return self::getOperatorStack()->getOperator($this->flowId, $operator);
            }
        }
        return NULL;
    }

    public static function getNextLink($flowId, $fromOperatorId, $fromPortId){
        foreach(self::$links[$flowId] as $link){
            if($link['fromOperator'] == $fromOperatorId && $link['fromConnector'] == $fromPortId){
                return $link;
            }
        }
        return false;
    }

    public static function getNextElement($flowId, $flowName, $nextLinkParam){
        if(empty($nextLinkParam))
            return false;

        foreach(self::$operators[$flowId] as $operatorParams){
            $opId = $operatorParams['id'];
            if($opId == $nextLinkParam['toOperator']){
                self::getOperatorStack()->getOperator($flowId, $operatorParams);
                if(self::getOperatorStack()->operatorExists($flowId, $opId)){
                    self::setInData($flowId, $flowName, $opId);
                    self::getOperatorStack()->operators[$flowId][$opId]->process(array('flowId' => $flowId, 'flowName' => $flowName));
                    if(empty(self::getOperatorStack()->operators[$flowId][$opId]))
                        return false;

                    return self::getNextLink(
                        $flowId,
                        self::getOperatorStack()->operators[$flowId][$opId]->getElementId(),
                        self::getOperatorStack()->operators[$flowId][$opId]->getOutControlPort()
                    );
                }
                return false;
            }
        }
        return false;
    }

    protected static function setInData($flowId, $flowName, $operatorId){
        $toOperatorId = self::getOperatorStack()->operators[$flowId][$operatorId]->getElementId();

        $inputDataPorts = self::getOperatorStack()->operators[$flowId][$operatorId]->getInDataPorts();

        foreach($inputDataPorts as $inPortKey => $inDataPort){
            $prevLink = self::getPrevLink($flowId, $toOperatorId, $inPortKey);
            if(empty($prevLink))
                continue;
            if(!empty(self::getOperatorStack()->operators[$flowId][$prevLink['fromOperator']])){
                $value = self::getOperatorStack()->operators[$flowId][$prevLink['fromOperator']]->getOutDataByPortId($prevLink['fromConnector']);
                self::getOperatorStack()->operators[$flowId][$operatorId]->setInDataPortById($inPortKey, $value);
            }else{
                self::getPrevElementForDataFlow($flowId, $flowName, $prevLink['fromOperator']);
                $value = self::getOperatorStack()->operators[$flowId][$prevLink['fromOperator']]->getOutDataByPortId($prevLink['fromConnector']);
                self::getOperatorStack()->operators[$flowId][$operatorId]->setInDataPortById($inPortKey, $value);
            }
        }
    }

    protected static function getPrevLink($flowId, $toOperatorId, $toPortId){
        $count = self::countPrevLinks($flowId, $toOperatorId, $toPortId);
        if($count){
            foreach(self::$links[$flowId] as $link){
                if($link['toOperator'] == $toOperatorId && $link['toConnector'] == $toPortId){
                    if($count == 1){
                        return $link;
                    }elseif(!empty(self::getOperatorStack()->operators[$flowId][$link['fromOperator']])){
                        return $link;
                    }
                }
            }
        }
        return array();
    }

    protected static function countPrevLinks($flowId, $toOperatorId, $toPortId){
        $count = 0;
        foreach(self::$links[$flowId] as $link){
            if($link['toOperator'] == $toOperatorId && $link['toConnector'] == $toPortId){
                $count++;
            }
        }
        return $count;
    }

    protected static function getPrevElementForDataFlow($flowId, $flowName, $elemId){
        foreach(self::$operators[$flowId] as $operatorInfo){
            if($operatorInfo['id'] == $elemId){
                self::getOperatorStack()->getOperator($flowId, $operatorInfo);
                self::setInData($flowId, $flowName, $elemId);
                self::getOperatorStack()->operators[$flowId][$elemId]->process(array('flowId' => $flowId, 'flowName' => $flowName));
            }
        }
    }

    protected static function getOperatorStack(){
        return OperatorStack_lb6038ea32798897_77942078::getInstance();
    }

}

