<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb6038ea32798897_77942078/operators/FlowchartOperatorFactory_lb6038ea32798897_77942078.php';

class OperatorStack_lb6038ea32798897_77942078{

    protected static $instance;

    public $operators;
    public $for_each_operators;

    protected function __construct(){

    }

    public static function getInstance(){
        if(empty(self::$instance)){
            self::$instance = new OperatorStack_lb6038ea32798897_77942078();
        }
        return self::$instance;
    }

    public function addOperator($flowId, $operator){
        $this->operators[$flowId][$operator['id']] = FlowchartOperatorFactory_lb6038ea32798897_77942078::getEntity($operator);
    }

    public function operatorExists($flowId, $operatorId){
        return !empty($this->operators[$flowId][$operatorId]);
    }

    public function getOperatorById($flowId, $id){
        return $this->operators[$flowId][$id];
    }

    /**
     * @param $flowId
     * @param $params
     * @return FlowchartOperator_lb6038ea32798897_77942078
     */
    public function getOperator($flowId, $params){
        $elemId = $params['id'];
        if(!$this->operatorExists($flowId, $elemId))
            $this->addOperator($flowId, $params);

        return $this->getOperatorById($flowId, $elemId);
    }

    /**
     * @param $flowId
     * @param $opId
     * @return FlowchartOperator_lb6038ea32798897_77942078
     */
    public function getOperatorOne($flowId, $opId){
        return !empty($this->operators[$flowId][$opId]) ? $this->operators[$flowId][$opId] : $this->getForEachOperator($flowId, $opId);
    }

    public function setForEachOperator($flowId, $loopId, $params){
        if(empty($this->for_each_operators[$flowId][$loopId][$params['id']]))
            $this->for_each_operators[$flowId][$loopId][$params['id']] = FlowchartOperatorFactory_lb6038ea32798897_77942078::getEntity($params);
    }

    public function getForEachOperator($flowId, $opId){
        if(is_array($this->for_each_operators[$flowId]))
            foreach($this->for_each_operators[$flowId] as $loopOperators){
                if(!empty($loopOperators[$opId]))
                    return $loopOperators[$opId];
            }
        return null;
    }

    public function clearForEachOperators($flowId, $loopId){
        unset($this->for_each_operators[$flowId][$loopId]);
    }

}
