<?php

class DateTimeConverter_lb6038ea32798897_77942078{

    protected static $instance;

    protected function __construct(){

    }

    /**
     * @return DateTimeConverter_lb6038ea32798897_77942078
     */
    protected static function getInstance(){
        if(empty(static::$instance))
            static::$instance = new DateTimeConverter_lb6038ea32798897_77942078();

        return static::$instance;
    }

    public static function convertToDisplay($defs, $date){
        $instance = self::getInstance();
        $type = $instance->getType($defs);

        if($instance->isUserPortal()){
            global $timedate, $current_user;

            $tmpDate = $instance->isInDisplayFormat($date, $type);
            if($tmpDate){
                $date = $tmpDate->format($timedate->get_db_date_time_format());
            }

            if($type == 'datetime'){
                $date = $instance->covertToDisplayWithLocalTimezone($date, $timedate->get_date_time_format($current_user));
            }else{
                $date = $instance->covertToDisplayWithLocalTimezone($date, $timedate->get_date_format($current_user));
            }
        }else{
            if(!self::getInstance()->isInDisplayFormat($date, $type)){
                $date = self::getInstance()->toDisplayFormat($date, $type);
            }
        }

        return $date;
    }

    public static function convertToDb($defs, $date){
        $instance = self::getInstance();
        $type = $instance->getType($defs);

        if($instance->isInDisplayFormat($date, $type)){
            $date = $instance->toDbFormat($date, $type);
        }

        return $date;
    }

    public static function convertDateForEntitySet($defs, $date){
        $instance = self::getInstance();
        $type = $instance->getType($defs);
        global $timedate;

        if($instance->isUserPortal()){

            $tmpDate = $instance->isInDisplayFormat($date, $type);
            if($tmpDate){
                $date = $tmpDate->format($timedate->get_db_date_time_format());
            }
            if($type == 'datetime'){
                $date = $instance->covertToDbWithUTCTimezone($date, $timedate->get_db_date_time_format());
            }else{
                $date = $instance->covertToDbWithUTCTimezone($date, $timedate->get_db_date_time_format());
            }
        }
        else{
            $date = self::convertToDb($defs, $date);
        }
        return $date;
    }

    public function getType($defs){
        return $defs['type'] == 'date' ? 'date' : 'datetime';
    }

    public static function getSugarDatetime($date, $type){
        global $timedate, $current_user;

        $sugarDT = $timedate->fromUserType($date, $type, $current_user);
        if(empty($dateTime))
            $sugarDT = $timedate->fromDbType($date, $type);

        return $sugarDT;
    }

    public function isInDisplayFormat($date, $type){
        global $timedate, $current_user;
        return $timedate->fromUserType($date, $type, $current_user);
    }

    public function toDisplayFormat($date, $type){
        global $timedate, $current_user;
        if($type == 'datetime'){
            $date = $timedate->to_display_date_time($date);
        }elseif($type == 'date'){
            $date = $timedate->to_display_date($date, false);
        }

        return $date;
    }

    public function toDbFormat($date, $type){
        global $timedate;
        if($type == 'datetime'){
            $date = $timedate->to_db_date($date) . ' ' . $timedate->to_db_time($date);
        }elseif($type == 'date'){
            $date = $timedate->to_db_date($date, false);
        }

        return $date;
    }

    public function isUserPortal(){
        global $current_user;
        return $current_user->user_name == 'SugarCustomerSupportPortalUser';
    }

    public function covertToDisplayWithLocalTimezone($date, $format){
        $currTimezone = date_default_timezone_get();
        $dateObj = new DateTime($date, new DateTimeZone('UTC'));
        $dateObj->setTimezone(new DateTimeZone($currTimezone));
        $sugarDate = $dateObj->format($format);
        return $sugarDate;
    }

    public function covertToDbWithUTCTimezone($date, $format){
        global $timedate;

        $utcTimezone = new DateTimeZone('UTC');
        $browserTimezone= new DateTimeZone(date_default_timezone_get());
        $dateObj = new DateTime($date, $browserTimezone);
        $dateObj->setTimezone($utcTimezone);
        $sugarDate = $dateObj->format($format);
        return $sugarDate;
    }

}
