<?php

require_once "modules/Mailer/AttachmentPeer.php";
require_once "modules/Mailer/Attachment.php";

class FlowchartAttachmentPeer_lb6038ea32798897_77942078{

    protected $saveAttachmentsAsNotes = null;

    protected $attachedNotes = array();
    protected $temporaryFiles = array();



    protected $mailer;
    protected $attachments;

    public function __construct($saveAttachmentsAsNotes){
        $this->saveAttachmentsAsNotes = $saveAttachmentsAsNotes;
    }



    public function setMailer($mailer){
        $this->mailer = $mailer;
    }

    public function processFiles($attachments){
        if(is_array($attachments)){
            $attachments = !empty($attachments['collectionData']) ? $attachments['collectionData'] : $attachments;
            foreach($attachments as $file){
                $this->processAttachment($file);
            }
        }else{
            $this->processAttachment($attachments);
        }
        return $this->attachments;
    }

    protected function processAttachment($attachment){
        global $mod_strings, $sugar_config;

        $file_location = '';
        $filename = '';
        $mime_type = 'text/plain';

        if ($attachment instanceof Note) {
            if (!empty($attachment->file->temp_file_location) &&
                //TODO:START: Removed because of packageScan
                //is_file($attachment->file->temp_file_location)
                SugarAutoloader::fileExists($attachment->file->temp_file_location)
                //TODO:END: Removed because of packageScan
            ) {
                $file_location = $this->getUploadDir() . "://{$attachment->id}";
                $filename = $attachment->file->original_file_name;
                $mime_type = $attachment->file->mime_type;
            } else {
                $file_location = $this->getUploadDir() . "://{$attachment->id}";
                $filename = !empty($attachment->filename) ? $attachment->filename : $attachment->name;
                $mime_type = $attachment->file_mime_type;
            }
            $this->attachedNotes[] = $attachment;
        } elseif ($attachment instanceof DocumentRevision || $attachment instanceof Document) {
            if($attachment instanceof Document){
                if(empty($attachment->latest_document_revision_link))
                    $attachment->load_relationship('latest_document_revision_link');
                $lastRevisions = $attachment->latest_document_revision_link->getBeans();
                if(!empty($lastRevisions))
                    $attachment = array_pop($lastRevisions);
            }
            $filePathName = $attachment->id;
            $filename = $attachment->getDocumentRevisionNameForDisplay();
            $file_location = $this->getUploadDir() . "://{$attachment->id}";
            $mime_type = $attachment->file_mime_type;

            $this->saveAttachmentAsNote($filename, $mime_type, $filePathName);
        } elseif($attachment instanceof FlowchartPdfFile_lb6038ea32798897_77942078) {
            $filename = $attachment->saveFile();
            $file_location = $this->getUploadDir() . "://" . $filename;
            $mime_type = $attachment->getFileMimeType();
            $this->temporaryFiles[] = $file_location;

            $this->saveAttachmentAsNote($filename, $mime_type, $filename);
        }
        else {
            return null;
        }

        $filename = str_replace($mod_strings['LBL_EMAIL_ATTACHMENT'].': ', '', $filename);
        //TODO:START: Removed because of packageScan
        //$file_ext = pathinfo($filename, PATHINFO_EXTENSION);
        $file_ext = end(explode('.', $filename));
        //TODO:END: Removed because of packageScan
        foreach ($sugar_config['upload_badext'] as $badExt) {
            if (strtolower($file_ext) == strtolower($badExt)) {
                $file_location = $file_location . ".txt";
                break;
            }
        }

        if($this->isSugarBeanEntity($attachment)){
            if($attachment->embed_flag == true){
                $cid = $filename;
                $this->attachments[] = AttachmentPeer::embeddedImageFromSugarBean($attachment, $cid);
            } else{
                $this->attachments[] = AttachmentPeer::attachmentFromSugarBean($attachment);
            }
        }else{
            $filePath = $file_location;
            $fileName = $filename;
            $mimeType = $mime_type;
            //TODO:START: Removed because of packageScan
            //if (!is_file($filePath)) {
            if (!SugarAutoloader::fileExists($filePath)) {
            //TODO:END: Removed because of packageScan
                throw new MailerException(
                    "Invalid Attachment: file not found: {$filePath}",
                    MailerException::InvalidAttachment
                );
            }

            $this->attachments[] = new Attachment($filePath, $fileName, Encoding::Base64, $mimeType);
        }
    }

    protected function getUploadDir(){
        return rtrim(SugarConfig::getInstance()->get('upload_dir', 'upload'), '/\\');
    }

    protected function saveAttachmentAsNote($filename, $mimeType, $fileLocation){
        if(!$this->saveAttachmentsAsNotes)
            return;

        $note = BeanFactory::getBean('Notes');
        $note->filename = $filename;
        $note->file_mime_type = $mimeType;
        $note->name = $note->filename;
        if(empty($note->id)){
            $note->id = Sugarcrm\Sugarcrm\Util\Uuid::uuid1();
            $note->new_with_id = true;
        }
        $note->save();

        require_once('include/upload_file.php');
        $uploadFile = new UploadFile();
        //TODO:START: Removed because of packageScan
        //$uploadFile->temp_file_location = UploadFile::get_upload_path( $fileLocation );
        //$fileContents = $uploadFile->get_file_contents();
        //file_put_contents("upload://{$note->id}", ltrim($fileContents));
        $result = $uploadFile->duplicate_file($fileLocation, $note->id);
        //TODO:END: Removed because of packageScan

        $this->attachedNotes[] = $note;
    }

    protected function isSugarBeanEntity($attr){
        return $attr instanceof Document || $attr instanceof Note || $attr instanceof DocumentRevision;
    }

    public function cleanUp(){
        foreach($this->temporaryFiles as $fileLocation){
            if($fileLocation){
                //TODO:START: Removed because of packageScan
                //SugarAutoLoader::unlink($fileLocation);
                //TODO:END: Removed because of packageScan
            }
        }
    }

    public function getAttachedNotes(){
        return $this->attachedNotes;
    }

    public function getAttachments(){
        return $this->attachedNotes;
    }
}
