<?php



class RestHelper_lb6038ea32798897_77942078{


    public static function call(
        $url,
        $type='GET',
        $headers = array(),
        $arguments=array(),
        $proxy,
        $httpAuth = null//,
        //$encodeData=true,
        //$returnHeaders=false
    )
    {

        $type = strtoupper($type);

        if ($type == 'GET' && !empty($arguments)) {
            if(strpos($url, '?')){
                $url .= "&" . http_build_query($arguments);
            }else{
                $url .= "?" . http_build_query($arguments);
            }
        }

        //$GLOBALS['log']->fatal('URL: ' . $url);

        $curl_request = curl_init($url);

        if ($type == 'POST'){
            curl_setopt($curl_request, CURLOPT_POST, 1);
        }
        elseif ($type == 'PUT'){
            curl_setopt($curl_request, CURLOPT_CUSTOMREQUEST, "PUT");
        }
        elseif ($type == 'DELETE'){
            curl_setopt($curl_request, CURLOPT_CUSTOMREQUEST, "DELETE");
        }

        curl_setopt($curl_request, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
        //curl_setopt($curl_request, CURLOPT_HEADER, $returnHeaders); //false
        curl_setopt($curl_request, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl_request, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl_request, CURLOPT_FOLLOWLOCATION, 0);

        if(!empty($headers)){
            $curlHeaders = array();
            if(is_array($headers))
                foreach($headers as $hName => $hValue)
                    $curlHeaders[] = "$hName: $hValue";
            curl_setopt($curl_request, CURLOPT_HTTPHEADER, $curlHeaders);
            //$GLOBALS['log']->fatal('HTTPHEADER: ' . print_r($curlHeaders, true));
        }


        if (!empty($arguments) && $type !== 'GET')
        {
            //if ($encodeData){
            if (!is_string($arguments)){
                $arguments = json_encode($arguments);
            }
            curl_setopt($curl_request, CURLOPT_POSTFIELDS, $arguments);
        }

        if(!empty($proxy)){
            if(!empty($proxy['host']) && !empty($proxy['port'])){
                curl_setopt($curl_request, CURLOPT_PROXY, $proxy['host'] . ':' . $proxy['port']);
                //$GLOBALS['log']->fatal('PROXY: ' . $proxy['host'] . ':' . $proxy['port']);
            }if(!empty($proxy['username']) && !empty($proxy['password'])){
                curl_setopt($curl_request, CURLOPT_PROXYUSERPWD, $proxy['username'] . ':' . $proxy['password']);
                //$GLOBALS['log']->fatal('PROXY AUTH: ' . $proxy['username'] . ':' . $proxy['password']);
            }
        }
        if(!empty($httpAuth) && is_array($httpAuth)){
            curl_setopt($curl_request, CURLOPT_USERPWD, $httpAuth['username'] . ':' . $httpAuth['password']);

            //$GLOBALS['log']->fatal('AUTH: ' . $httpAuth['username'] . ':' . $httpAuth['password']);
        }

        $result = curl_exec($curl_request);

        //$GLOBALS['log']->fatal('RESULT:' . print_r($result, true));

        if(empty($result)){
            curl_close($curl_request);
            return array();
        }

//		if ($returnHeaders)
//		{
//			//set headers from response
//			list($headers, $content) = explode("\r\n\r\n", $result ,2);
//			foreach (explode("\r\n",$headers) as $header)
//			{
//				header($header);
//			}
//
//			//return the nonheader data
//			return trim($content);
//		}


        //$GLOBALS['log']->fatal('$result' . print_r($result, true));

        $info = curl_getinfo($curl_request);
        curl_close($curl_request);
        return array(
            'result' => $result,
            'info' => $info,
            );
    }
}
