<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb6038ea32798897_77942078/operators/FlowchartOperator_lb6038ea32798897_77942078.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb6038ea32798897_77942078/helpers/date/DateTimeFactory_lb6038ea32798897_77942078.php';

class SetEntityAttributesOperator_lb6038ea32798897_77942078_op8 extends FlowchartOperator_lb6038ea32798897_77942078{

    protected $entity;
    protected $attributes;

    public function __construct($params){
        parent::__construct($params);
    }

    public function process($params = array()){
        $this->initBeanWithInData();
    }

    protected function initBeanWithInData(){
        $fieldDef = $this->entity->field_defs['currency_symbol_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->currency_symbol_c = $this->getDateInDbFormat(
                    $this->attributes['currency_symbol_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->currency_symbol_c = $this->getDateTimeInDbFormat(
                    $this->attributes['currency_symbol_c']
                );
                break;
            default:
                $this->entity->currency_symbol_c = $this->attributes['currency_symbol_c'];
            }
    }

    private function getDateInDbFormat($value)
    {
        $date = $this->getDateTimeFromValue($value);
        if (empty($date)) {
            return null;
        }
        return $date->asDbDate(false);
    }

    private function getDateTimeInDbFormat($value)
    {
        $dateTime = $this->getDateTimeFromValue($value);
        if (empty($dateTime)) {
            return null;
        }
        return $dateTime->asDb(true);
    }

    private function getDateTimeFromValue($date)
    {
        if ($date instanceof SugarDateTime) {
            return $date;
        }
        if (!is_string($date)) {
            return null;
        }
        $dateTimeFactory = new DateTimeFactory_lb6038ea32798897_77942078();
        return $dateTimeFactory->getDateTimeFromUnknownFormat($date);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($value instanceof SugarBean){
                $this->entity = $value;
            }else{
                $this->attributes[$this->inDataPorts[$id]['value']] = $value;
            }
        }
    }

    public function getOutDataByPortId($portId){
        return $this->entity;
    }

}
